local mod = ...


-- -- Job: Withy Gatherer -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "JOB",
-- 	Id = "WITHYGATHERER_JOB",
-- 	JobName = "WITHYGATHERER_JOB_NAME",
-- 	JobDescription = "WITHYGATHERER_JOB_DESC",
-- 	IsLockedByDefault = false,
-- 	DefaultBehavior = "BEHAVIOR_WORK",
-- 	-- UseWorkplaceBehavior = true,
--     ProductionDelay = 80.0, -- default 30
-- 	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
-- 	CharacterSetup = {
-- 		DataType = "CHARACTER_SETUP", 
-- 		-- LeftHandObject = {
-- 		-- 	Model = "PREFAB_TOOL_FARMER_SEED_BAG", 
-- 		-- 	WorkAttachName = "SeedBag_Anchor", 
-- 		-- 	WalkAttachName = "SeedBag_Anchor"
-- 		-- },
-- 		WalkAnimation = "WALKING",
-- 		IdleAnimation = "IDLE"
-- 	}
-- })

-- mod:override({
--     Id = "NEWCOMER",
--     CompatibleJobList = {
--         Action = "APPEND",
--         "WITHYGATHERER_JOB"
--     }
-- })

-- mod:override({
--     Id = "SERF",
--     CompatibleJobList = {
--         Action = "APPEND",
--         "WITHYGATHERER_JOB"
--     }
-- })



-- Job: Joiner -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOINER_JOB",
	JobName = "JOINER_JOB_NAME",
	JobDescription = "JOINER_JOB_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 30.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_FARMER_SEED_BAG", 
		-- 	WorkAttachName = "SeedBag_Anchor", 
		-- 	WalkAttachName = "SeedBag_Anchor"
		-- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOINER_JOB"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOINER_JOB"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOINER_JOB"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOINER_JOB"
    }
})



-- Resource Type: Furniture
mod:registerEnumValue( "RESOURCE_TYPE", "FURNITURE_RESOURCE_TYPE" )



-- Resource -------------------------------------------------------------------------------------

-- mod:registerAssetId("icons/Withy.png", "ICON_WITHY")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "WITHY_RESOURCE",
-- 	ResourceName = "WITHY_RESOURCE_NAME",
-- 	Icon = "ICON_WITHY",
-- 	ResourceTypeList = { "RESOURCE" },
-- 	IsTradable = true,
-- 	ResourceLayoutType = "CRATES",
-- 	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 4 },
-- 	DisplayInInventory = true
-- })

mod:registerAssetId("icons/Table.png", "ICON_FURNITURE")

mod:register({
	DataType = "RESOURCE",
	Id = "FURNITURE_RESOURCE",
	ResourceName = "FURNITURE_RESOURCE_NAME",
	Icon = "ICON_FURNITURE",
	ResourceTypeList = { "GOODS", "FURNITURE_RESOURCE_TYPE" },
	IsTradable = true,
	ResourceLayoutType = "CRATES",
	VillagerBuyingPrice = { Resource = "GOLD", Quantity = 10 },
	DisplayInInventory = true
})



-- Assets
mod:registerAssetId("models/JoinerWorkshop2.fbx/Prefab/CounterPart/Chair.001", "PREFAB_JOINERWORKSHOPCHAIR")

mod:registerAssetId("models/JoinerWorkshop1.fbx/Prefab/WorkshopPart", "PREFAB_JOINERWORKSHOP1")
mod:registerAssetId("models/JoinerWorkshop2.fbx/Prefab/WorkshopPart", "PREFAB_JOINERWORKSHOP2")
mod:registerAssetId("models/JoinerWorkshop2.fbx/Prefab/CounterPart", "PREFAB_JOINERWORKSHOPCOUNTER")
-- mod:registerAssetId("models/WillowCoppice.fbx/Prefab/CoppicePart", "PREFAB_WILLOWCOPPICE")



-- Building Asset Processor
mod:registerAssetProcessor("models/JoinerWorkshop1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/JoinerWorkshop2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
-- mod:registerAssetProcessor("models/WillowCoppice.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Construction visual
mod:registerAssetId("models/JoinerWorkshop1.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_JOINERWORKSHOP1")
mod:registerAssetId("models/JoinerWorkshop2.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_JOINERWORKSHOP2")
-- mod:registerAssetId("models/WillowCoppice.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_WILLOWCOPPICE")



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/JoinerWorkshop1.fbx/Prefab/WorkshopPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/JoinerWorkshop2.fbx/Prefab/WorkshopPart", { "PLATFORM" })



-- Grounding
mod:registerPrefabComponent("models/JoinerWorkshop2.fbx/Prefab/CounterPart/Bench.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/JoinerWorkshop2.fbx/Prefab/CounterPart/Table.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/JoinerWorkshop2.fbx/Prefab/CounterPart/Chair.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/JoinerWorkshop2.fbx/Prefab/CounterPart/Chair.001", {DataType = "COMP_GROUNDED"})



-- Grounding construction visuals
-- for i=1, 4, 1 do
-- 	mod:registerPrefabComponent("models/WillowCoppice.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
-- end



-- Grounding coppice stumps
-- for i=1, 50, 1 do
-- 	mod:registerPrefabComponent("models/WillowCoppice.fbx/Prefab/CoppicePart/Coppice." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
-- end



-- Building part type
mod:registerEnumValue("BUILDING_PART_TYPE", "COUNTER")



-- Building Function: Furniture  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "FURNITURE_FUNCTION",
    Name = "FURNITURE_FUNCTION_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOINER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		-- { Resource = "WITHY_RESOURCE", Quantity = 25 },
		-- { Resource = "WOOD", Quantity = 25 },
		{ Resource = "PLANK", Quantity = 25 },
		{ Resource = "WOOLEN_CLOTH", Quantity = 25 },
	},
    ResourceListNeeded = {
		-- { Resource = "WITHY_RESOURCE", Quantity = 1 },
		-- { Resource = "WOOD", Quantity = 1 },
		{ Resource = "PLANK", Quantity = 1 },
		{ Resource = "WOOLEN_CLOTH", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "FURNITURE_RESOURCE", Quantity = 1 }
	}
})



-- Building Function: Sales Counter -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "FURNITURECOUNTER_FUNCTION",
    Name = "FURNITURECOUNTER_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "FURNITURE_RESOURCE_TYPE" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 30,
	InputInventoryCapacity = {
		{ Resource = "FURNITURE_RESOURCE", Quantity = 30 },
	},
    ResourceListNeeded = {
		{ Resource = "FURNITURE_RESOURCE", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "FURNITURE_RESOURCE", Quantity = 10 },
	}
})



-- Building: Joiner's Workshop -------------------------------------------------------------------------------------

mod:register({
	DataType = "BUILDING", 
	Id = "JOINERWORKSHOP",
	Name = "JOINERWORKSHOP_NAME",
	Description = "JOINERWORKSHOP_DESC",
	BuildingType = "GENERAL",
	VillagerRequired = { Status = "COMMONER", Quantity = 5 },
	AssetCoreBuildingPart = "JOINERWORKSHOPCHAIR_PART",
	BuildingPartSetList = {
		{
			Name = "JOINERWORKSHOP_SET1_NAME",
			BuildingPartList = { 
				"JOINERWORKSHOP1_PART",
				"JOINERWORKSHOP2_PART",
			}
		},
		{
			Name = "JOINERWORKSHOP_SET2_NAME",
			BuildingPartList = { 
				"JOINERWORKSHOPCOUNTER_PART",
			}
		}

	},	
	RequiredPartList = {
		{ Category = "CORE", Min = 1, Max = 1 }
	},
	IsEditable = true	
})




-- Building Part: Chair (building placeholder) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "JOINERWORKSHOPCHAIR_PART",
	Name = "JOINERWORKSHOP_PART_NAME", 
	Description = "JOINERWORKSHOP_PART_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_JOINERWORKSHOPCHAIR"
	},
	IsVisibleWhenBuilt = false
})



-- Building Part: Joiner's Workshop model 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "JOINERWORKSHOP1_PART",
	Name = "JOINERWORKSHOP_PART_NAME", 
	Description = "JOINERWORKSHOP_PART_DESC", 
	Category = "CORE", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_JOINERWORKSHOP1"
	},
	ConstructionVisual = "PREFAB_CONSTR_JOINERWORKSHOP1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7.0, 9.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "FURNITURE_FUNCTION",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 25 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
		RessourcesNeeded = {
            { Resource = "STONE", Quantity = 10 },
            { Resource = "WOOD", Quantity = 10 },
            { Resource = "PLANK", Quantity = 10 },
            { Resource = "TOOL", Quantity = 5 }
		}
	}
})



-- Building Part: Joiner's Workshop model 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "JOINERWORKSHOP2_PART",
	Name = "JOINERWORKSHOP_PART_NAME", 
	Description = "JOINERWORKSHOP_PART_DESC", 
	Category = "CORE", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_JOINERWORKSHOP2"
	},
	ConstructionVisual = "PREFAB_CONSTR_JOINERWORKSHOP2",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7.0, 9.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "FURNITURE_FUNCTION",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 25 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
		RessourcesNeeded = {
            { Resource = "STONE", Quantity = 10 },
            { Resource = "WOOD", Quantity = 10 },
            { Resource = "PLANK", Quantity = 10 },
            { Resource = "TOOL", Quantity = 5 }
		}
	}
})



-- Building Part: Sales counter -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "JOINERWORKSHOPCOUNTER_PART",
	Name = "JOINERWORKSHOPCOUNTER_PART_NAME", 
	Description = "JOINERWORKSHOPCOUNTER_PART_DESC", 
	Category = "COUNTER", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_JOINERWORKSHOPCOUNTER"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.5, 2.5}, {-0.5, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "FURNITURECOUNTER_FUNCTION",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 4 },
		}
	}
})



-- Building Function: Coppice  -------------------------------------------------------------------------------------
-- mod:register({
--     DataType = "BUILDING_FUNCTION_WORKPLACE",
--     Id = "COPPICE_FUNCTION",
--     Name = "COPPICE_FUNCTION_NAME",
--     WorkerCapacity = 1,
--     RelatedJob = { 
--         Job = "WITHYGATHERER_JOB", 
--         Behavior = "BEHAVIOR_WORK"
--     },
--     InputInventoryCapacity = {
-- 		{ Resource = "WATER", Quantity = 5 }
-- 	},
--     ResourceListNeeded = {
-- 		{ Resource = "WATER", Quantity = 1 }
-- 	},
--     ResourceProduced = {
-- 		{ Resource = "WITHY_RESOURCE", Quantity = 1 }
-- 	}
-- })



-- Building: Coppice -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING", 
-- 	Id = "COPPICE",
-- 	Name = "COPPICE_NAME",
-- 	Description = "COPPICE_DESC",
-- 	BuildingType = "GENERAL",
-- 	AssetCoreBuildingPart = "WILLOWCOPPICE_PART"
-- })



-- Building Part: Willow Coppice -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "WILLOWCOPPICE_PART",
-- 	Name = "WILLOWCOPPICE_PART_NAME", 
-- 	Description = "WILLOWCOPPICE_PART_DESC", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_WILLOWCOPPICE"
-- 	},
-- 	ConstructionVisual = "PREFAB_CONSTR_WILLOWCOPPICE",
-- 	BuildingZone = { 
--         ZoneEntryList = {
--             { 
--                 Polygon = polygon.createRectangle( {9.0, 9.0}, {0.0, 0.0} ),
--                 Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
-- 			}
-- 		}
-- 	},
-- 	AssetBuildingFunction = "COPPICE_FUNCTION",
-- 	Cost = {
-- 		-- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 25 } },
-- 		-- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
-- 		RessourcesNeeded = {
--             { Resource = "TOOL", Quantity = 1 }
-- 		}
-- 	}
-- })
